--
-- Made for MF 135
--
-- Made by:
-- Martin Schmidt
-- 25/01/10
--
-- Copyright (C) 

SteeringSystem = {};

function SteeringSystem.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function SteeringSystem:load(xmlFile)
	
	self.correctSteering = SpecializationUtil.callSpecializationsFunction("correctSteering");
	
	local count = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.steeringSystem#count"), 0);	
	
	self.myLinkages = {};	
	for i=1, count, 1 do
		self.myLinkages[i] = {};
		local name = string.format("vehicle.steeringSystem.Steering%d", i);		
				  
		self.myLinkages[i].InvertRotation = getXMLBool(xmlFile, name .. "#InvertRotation");
				  
		self.myLinkages[i].Fender = Utils.indexToObject(self.components, getXMLString(xmlFile, name .. "#Fender"));
		self.myLinkages[i].SteeringArm = Utils.indexToObject(self.components, getXMLString(xmlFile,  name .. "#SteeringArm"));
		self.myLinkages[i].FollowArmFront = Utils.indexToObject(self.components, getXMLString(xmlFile,  name .. "#FollowArmFront"));
		self.myLinkages[i].FollowArmBack = Utils.indexToObject(self.components, getXMLString(xmlFile,  name .. "#FollowArmBack"));
		self.myLinkages[i].FollowArmPoint = Utils.indexToObject(self.components, getXMLString(xmlFile,  name .. "#FollowArmPoint"));
	end;
	
	
end;



function SteeringSystem:update(dt)
	if self:getIsActive() then
		for k,v in pairs(self.myLinkages) do 
			self:correctSteering(k);
		end;
	end;
end;

function SteeringSystem:correctSteering(i)
	if self.myLinkages[i] ~= nil then
		local x, y, z = getRotation(self.myLinkages[i].Fender);
		
		if self.myLinkages[i].InvertRotation then
			setRotation(self.myLinkages[i].SteeringArm, -y, x, z);
		else
			setRotation(self.myLinkages[i].SteeringArm, y, x, z);
		end;
		
		local ax, ay, az = getWorldTranslation(self.myLinkages[i].FollowArmBack);
		local bx, by, bz = getWorldTranslation(self.myLinkages[i].FollowArmPoint);
		x, y, z = worldDirectionToLocal(getParent(self.myLinkages[i].FollowArmBack), bx-ax, by-ay, bz-az);
		setDirection(self.myLinkages[i].FollowArmBack, x, y, z, 0, 1, 0);	
		
		x, y, z = worldDirectionToLocal(getParent(self.myLinkages[i].FollowArmPoint), bx-ax, by-ay, bz-az);
		setDirection(self.myLinkages[i].FollowArmPoint, x, y, z, 0, 1, 0);
	end;
end;

function SteeringSystem:draw()
end;
function SteeringSystem:delete()
end;
function SteeringSystem:mouseEvent(posX, posY, isDown, isUp, button)
end;
function SteeringSystem:keyEvent(unicode, sym, modifier, isDown)
end;